<?php
Namespace App\Controller\Admin\Maintenance;

use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\HttpFoundation\JsonResponse;
use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use App\Model\Admin\HomegearBackup;
use App\Utils\Utils;

class BackupController extends Controller
{
    public function indexAction(Request $request, HomegearBackup $backup, Utils $utils)
    {
        $backup->removeOld();
        return $this->render('Admin/Maintenance/Backups/list.html.twig', array(
            'sect' => $request->attributes->get('sect'),
            'mgmt' => $utils->checkManagementRunning()
        ));
    }

    public function createAction(Request $request, HomegearBackup $backup)
    {
        $result = $backup->create();
        return new JsonResponse($result);
    }

    public function downloadAction(Request $request)
    {
        $params = $request->query->all();
        if (array_key_exists('backup', $params)) {
            $response = new Response();
            $response->headers->set('Cache-Control', 'private');
            $response->headers->set('Content-type', mime_content_type($params['backup']));
            $response->headers->set('Content-Disposition', 'attachment; filename="' . basename($params['backup']) . '";');
            $response->headers->set('Content-length', filesize($params['backup']));
            $response->sendHeaders();
            $response->setContent(file_get_contents($params['backup']));
            return $response;
        }
    }

    public function restoreAction(Request $request, HomegearBackup $backup)
    {
        $file = $request->files->get('backupfile');
        if ($file !== null) {
            $backup->restore($file);
        }
        return $this->redirectToRoute('admin.maintenance.backups.status');
    }

    public function restoreStatusAction(Request $request, HomegearBackup $backup)
    {
        $params = $request->query->all();
        if (array_key_exists('check',$params)) {
            return new JsonResponse($backup->checkStatus());
        } else {
            return $this->render('Admin/Maintenance/Backups/restorestatus.html.twig', array(
                'sect' => $request->attributes->get('sect')
            ));
        }
    }
}