<?php
Namespace App\Model\Admin;

Use App\Utils\Utils;

/**
 * Provides admin functions for Homegear service management
 *
 */
class HomegearBackup
{
    public $hg;
    private $utils;

    public function __construct(Utils $utils)
    {
        $this->hg = new \Homegear\Homegear;
        $this->utils = $utils;
    }

    /**
     * Delete old backups
     * 
     * @return none
     */
    public function removeOld()
    {
        exec("rm -f /tmp/*_homegear-backup.tar.gz");
    }

    /**
     * Create a backup
     * 
     * @return json
     */
    public function create()
    {
        $id = $this->hg->managementCreateBackup();
        $result = $this->utils->getCommandStatus($id);
        if ($result['exitCode'] == 0) {
            return ['result' => 'success', 'backup' => $result['metadata']['filename']];
        }
        return ['result' => 'error'];
    }

    /**
     * Restore a backup
     * 
     * @return json
     */
    public function restore($file = null)
    {
        if ($file === null) { return ['result' => 'error']; }
        $filename = $file->getClientOriginalName();
        rename($file->getPathname(), "/tmp/$filename");
        $this->hg->managementRestoreBackup("/tmp/$filename");
        return;
    }
}