<?php
Namespace App\Model\Admin;

use App\Model\HomegearVariable as BaseVariable;

/**
 * Provides admin functions for Homegear variable management
 *
 */
class HomegearVariable extends BaseVariable
{
    public function __construct()
    {
        parent::__construct();
    }

    /**
     * Create a system variable
     * 
     * @return int
     */
    public function create($name = null, $type = null) {
        if ($name === null || $type === null) { return; }
        switch ($type) {
            case "string":
                $result = $this->hg->setSystemVariable($name," ");
            break;
            case "int":
                $result = $this->hg->setSystemVariable($name,intval(1));
            break;
            case "float":
                $result = $this->hg->setSystemVariable($name,floatval(1.00));
            break;
            case "bool":
                $result = $this->hg->setSystemVariable($name,true);
            break;
            case "array":
                $result = $this->hg->setSystemVariable($name,[]);
            break;
            case "struct":
                $result = $this->hg->setSystemVariable($name,[[]]);
            break;
        }
        /*if ($result == -32700) {
            return $this->outputMessage("Data could not be encoded to binary format.",0);
        } elseif ($result == -32602) {
            return $this->outputMessage("Name is longer than 250 characters.",0);
        } elseif ($result == -32500) {
            return $this->outputMessage("The limit of 1 million metadata entries has been reached.",0);
        }*/
        return $result;
    }

    /**
     * Load a specific system variable
     * 
     * @return array()
     */
    public function loadByName($name = null) {
        if ($name === null) { return; }
        $v = $this->hg->getSystemVariable($name);
        $type = 'struct';
        $value = print_r($v, true);
        if (is_string($v)) { $type = 'string'; $value = $v; }
        if (is_int($v)) { $type = 'int'; $value = intval($v); }
        if (is_float($v)) { $type = 'float'; $value = floatval($v); }
        if (is_bool($v)) { $type = 'bool'; $value = boolval($v); }
        if (is_array($v)) { $type = 'array'; $value = print_r($v, true); }
        return ['name' => $name, 'type' => $type, 'value' => $value];
    }

    /**
     * Delete a system variable
     * 
     * @return none
     */
    public function delete($name = null) {
        if ($name === null) { return; }
        $this->hg->deleteSystemVariable($name);
    }

}