<?php
Namespace App\Model;

/**
 * Provides base functions for Homegear service messages
 *
 */
class HomegearServiceMessage
{
    public $hg;

    public function __construct()
    {
        $this->hg = new \Homegear\Homegear;
    }

    /**
     * Returns the service messages.
     *
     * @return array()
     */
    public function list()
    {
        $messages = $this->hg->getServiceMessages(true);
        if (count($messages) > 0) {
            foreach ($messages as $k => $message) {
                if ($message['TYPE'] == 1) {
                    // (hopefully) temporary hack for ccu: the serial is case-sensitive in db, but we only get uppercase back :/
                    if ($message['FAMILY_ID'] == 24) {
                        $messages[$k]['DATA']['SERIALNUMBER'] = strtoupper($message['DATA']['SERIALNUMBER']);
                        list($messages[$k]['MESSAGE'],$tmp) = explode('.',$message['MESSAGE']);
                    }
                }
                if ($message['TYPE'] == 2) {
                    $deviceInfo = $this->hg->getDeviceDescription(intval($message['PEER_ID']), -1, ["ADDRESS", "NAME"]);
                    $messages[$k]['deviceName'] = ($deviceInfo['NAME'] != '' ? $deviceInfo['NAME'] : $deviceInfo['ADDRESS']);
                }
                if (array_key_exists('NAME',$message)) {
                    $messages[$k]['MESSAGE'] = $message['NAME'];
                }
                $messages[$k]['TIMESTAMP'] = ($message['TIMESTAMP'] == 0 ? '' : date("d.m.Y H:i:s", $message['TIMESTAMP']));
            }
            return $messages;
        }
    }

    /**
     * Delete a service message
     * 
     * @return none
     */
    public function delete($id = null, $dp = null)
    {
        if ($id === null || $dp === null) { return; }
        $this->hg->setValue(intval($id), 0, "$dp", false);
    }
}