<?php
Namespace App\Model;

/**
 * Provides base functions for Homegear variables
 *
 */
class HomegearVariable
{
    public $hg;

    public function __construct()
    {
        $this->hg = new \Homegear\Homegear;
    }

    /**
     * Load all system variables
     * 
     * @return array()
     */
    public function loadAll() {
        $variables = array();
        $allVars = $this->hg->getAllSystemVariables();
        foreach ($allVars as $k => $v) {
            list($type,$value) = $this->_setType($v);
            $variables[] = ['name' => $k, 'type' => $type, 'value' => $value];
        }
        return (count($variables) > 0 ? $variables : null);
    }

    /**
     * Get the current type of a system variable
     * 
     * @return array()
     */
    public function _setType($v = null)
    {
        $type = 'struct';
        $value = print_r($v, true);
        if (is_string($v)) { $type = 'string'; $value = $v; }
        if (is_int($v)) { $type = 'int'; $value = intval($v); }
        if (is_float($v)) { $type = 'float'; $value = floatval($v);}
        if (is_bool($v)) { $type = 'bool'; $value = boolval($v);}
        if (is_array($v)) { $type = 'array'; $value = print_r($v, true);}
        return [$type, $value];
    }

}